#
#   Borland C++ makefile for building an FLL from a single C module.
#
#   Revision History
#   ----------------
#   24 May 1993     WRN     Created
#    3 Jun 1994     WRN     Updated for Borland C++ version 4.0
#
#   Command line invocation
#   -----------------------
#	Borland C++ version 3.1:
#
#		make -fwinbor.mak filename.fll
#
#	Borland C++ version 4.0:
#
#       make -fwinbor.mak -DBC4 filename.fll
#
#   Note: the .fll extension is required
#
# -----------------------------------------------------------------------


#   The following two lines must be set to correspond with the Borland
#   C++ and Foxpro LCK directories on your computer. They should NOT
#   include a trailing backslash even if referring to the root directory
#   Note that if you have installed BCC in a non-standard directory
#   structure (eg header files in ..\H instead of ..\INCLUDE) you will
#   have to edit other parts of the makefile as well
#
BORDIR = d:\apps\bc31   # directory where Borland C++ is installed
LCKDIR = d:\apps\foxlck # directory containing FoxPro API libraries,
                        # PRO_EXT.H, and _SETJMP.OBJ

#BC4    = 1              # set if using Borland C++ version 4.0

# Compiler command-line
# ---------------------
#   -c      Compile only
#   -ml     Use large memory model
#   -WDE    DLL, explicitly marked functions exported
#   -Oes    optimise for size
#   -w4     Set warning level to maximum
#   -P-     Turn C++ off by default (probably not needed)
#   -f      Emulate floating point (actually default for BCC)
#   -N-     No stack checking (also BCC default)
#   -I      include files directory
#
# Additional BC 4.0 options:
#   -x-     turn exception handling off
#   -RT-    do not include run-time type information
#
CC = $(BORDIR)\bin\bcc
CFLAGS = -c -ml -WDE -Oes -w4
CFLAGS = $(CFLAGS) -P- -f -N-
CFLAGS = $(CFLAGS) -I$(LCKDIR);$(BORDIR)\include
!ifdef BC4
CFLAGS = $(CFLAGS) -x- -RT-
!endif


# Linker command-line
# -------------------
#   /x      do not produce map file
#   /n      no default libraries (would otherwise search for MSC libs)
#   /Twd    Target Windows DLL
#   /P      pack code segments
#   /c      case-sensitive symbols
#   /L      library directories
#
LINK = $(BORDIR)\bin\tlink
LFLAGS = /x /n /Twd /P /c /L$(LCKDIR);$(BORDIR)\lib



# Standard object & library files
# -------------------------------
#   c0dl.obj    is the DLL startup code ('libentry') for large model
#   _setjmp.obj is needed for compatibility with MSC runtime library
#
STD_OBJS = $(BORDIR)\lib\c0dl.obj $(LCKDIR)\_setjmp.obj
LIBS     = proapiml.lib import.lib cwl.lib mathwl.lib



# Rules for creating the various steps along the way
# (including the rule to create an FLL, of course)
#
#
.c.obj :
    $(CC) @&&!
$(CFLAGS) $<
!

.obj.fll :
    echo LIBRARY $*                     > $*.def
    echo EXETYPE WINDOWS                >>$*.def
    echo CODE PRELOAD MOVABLE SHARED    >>$*.def
    echo DATA SHARED PRELOAD            >>$*.def
    $(LINK) @&&!
$(LFLAGS) +
$(STD_OBJS) $*.obj
$@
NUL
$(LIBS)
$*.def
!
   del $*.def

